#include <Encoder.h>


boolean rolltone[8][7] = {
    {false, false, false, true, false, false, true},
    {false, true, true, true, false, false, true},
    {false, false, false, true, true, false, false},
    {false, false, true, true, true, false, false},
    {false, false, true, true, true, false, true},
    {false, true, true, true, false, false, true},
    {false, true, false, true, false, false, true},
    {false, false, true, true, true, true, true}
  };
boolean scaleChar[7][7] = {
    {true, true, false, true, true, true, true},
    {true, true, true, true, true, true, true},
    {false, false, true, true, true, true, false},
    {true, true, true, true, true, true, false},
    {false, false, true, true, true, true, true},
    {false, false, false, true, true, true, true},
    {false, true, true, true, true, true, false}
  };



// PIN ASSIGNMENTS

const byte sclDispStart = 41;
const byte sclDispStep = 2;
byte sclDispEnd = sclDispStart * sclDispStep + 1;

const byte butUpPin = 48;
const byte butStPin = 46;
const byte butDnPin = 44;

byte potPin[3] = { A0, A2, A4 };

byte sclDispPins[] = { 43, 45, 49, 51, 47, 41, 53 };
const byte sclUpPin = 52;
const byte sclDnPin = 50;

byte encPins[8][2] = {
  {22, 23},
  {24, 25},
  {26, 27},
  {28, 29},
  {30, 31},
  {32, 33},
  {34, 35},
  {36, 37}
};

byte leTopStartPin = 2;
byte leBtmStartPin = 14;

// ENCODERS OBJs

byte encStartPin = 22;
Encoder encoder[8] = {
  Encoder(encPins[0][0], encPins[0][1]),
  Encoder(encPins[1][0], encPins[1][1]),
  Encoder(encPins[2][0], encPins[2][1]),
  Encoder(encPins[3][0], encPins[3][1]),
  Encoder(encPins[4][0], encPins[4][1]),
  Encoder(encPins[5][0], encPins[5][1]),
  Encoder(encPins[6][0], encPins[6][1]),
  Encoder(encPins[7][0], encPins[7][1])
};
  
  

// SETIP

void setup() {

  Serial.begin(9600);
  
  
  // SCALE AND DISPLAY INIT
  
  //byte j = 0;
  for (byte i = sclDispStart; i < sclDispEnd; i+=sclDispStep) {
    pinMode(i, OUTPUT);
    //sclDispPins[j] = i;
    //j++;
  }
  
  pinMode(sclUpPin, INPUT_PULLUP);
  pinMode(sclDnPin, INPUT_PULLUP);

  
  // BUTTONS AND POTS INIT
  
  pinMode(butUpPin, INPUT_PULLUP);
  pinMode(butStPin, INPUT_PULLUP);
  pinMode(butDnPin, INPUT_PULLUP);

  // ENCODERS INIT -- DONE IN VAR DEC
  
  /*for (byte i = 0; i < 8; i++) {
    encPins[i][0] = encStartPin + i;
    encPins[i][1] = encStartPin + i + 1;  
    encoder[i](encPins[i][0], encPins[i][1]);
  }*/
  
  // LED INIT
  
  for (byte i = leTopStartPin; i < leTopStartPin + 8; i++) {
    pinMode(i, OUTPUT);
  }
  
  for (byte i = leBtmStartPin; i < leBtmStartPin + 8; i++) {
    pinMode(i, OUTPUT);
  }
  
}

// the loop function runs over and over again forever
void loop() {

  //waitStartUp();
  
  sclUpdate();
  displayScale();
  
  butRead();
  //potRead();
  encRead();
  
}


void sendData(char* event, byte nr, int val) {
      Serial.print(event);
      Serial.print(nr);
      Serial.print(" ");
      Serial.println(val);
      //Serial.write("\n");
}
